/********************************************************************
 FileName:      Grafic LCD  AQM1248A.h pCu
 Processor:     PIC18F14K50
 Compiler:      Microchip XC8

v|[Viȍő5x7dot̕p^[񋟂ƂƂ
ȉ̋@\

  mInitLCD_IO()            G_LCDŎgpPICI/Os
  mInitSPI()               PICSPI@\

  LCD_int ()               G_LCD
  LCD_cmd (cmd)            G_LCDɃR}hf[^𑗐M
  LCD_dat (chr)            R[hchr𕶎p^[ɕϊ
                                G_LCDɕ\
  LCD_ram (dat)            G_LCDɃOtBbNf[^𑗐M
  LCD_clr ()               G_LCD̕\RAMS
  LCD_posyx (ypos, xpos)   G_LCD̕\RAMAhXw肷
  LCD_str(add)             PICRAM̈ɂ镶G_LCDɕ\
  LCD_ROMstr(r_add)        PICROM̈ɂ镶G_LCDɕ\

ȉ́A\ŁA̕\ʒuxposԂ
 xpos = LCD_chr1x(chr, ypos, xpos)      ʏ핶
 xpos = LCD_str1x(add, ypos, xpos)      RAM̈ʏ핶
 xpos = LCD_ROMstr1x(add, ypos, xpos)   ROM̈ʏ핶

 xpos = LCD_chr2x(chr, ypos, xpos)      Q{g啶
 xpos = LCD_str2x(add, ypos, xpos)      RAM̈Q{g啶
 xpos = LCD_ROMstr2x(r_add, ypos, xpos) RAM̈Q{g啶

 xpos = LCD_chr3x(chr, ypos, xpos)      R{g啶
 xpos = LCD_str3x(add, ypos, xpos)      RAM̈R{g啶
 xpos = LCD_ROMstr3x(r_add, ypos, xpos) RAM̈R{g啶

̈Ӗƃf[^^
 cmd   : char^f[^ G_LCDւ̃R}hf[^
 dat   : char^f[^ G_LCDւ̃OtBbNf[^
 chr   : char^f[^ G_LCDɕ\镶̃R[hf[^
 ypos  : char^f[^ G_LCD̕\RAM̏c(page)ʒu
 ypos  : unsigned char^f[^ G_LCD̕\RAM̉(column)ʒu
 add   : RAM̈̕JnAhX|C^
 r_add : ROM̈̕JnAhX|C^

  Copyright (c) 2014 iwamoto All Rights Reserved
********************************************************************
 File Description:

 Change History:
  Rev   Date         Description
  1.0   20014/1/2   Initial release
********************************************************************/

/******** vg^Cv *************************/
void LCD_int (void);
void LCD_cmd (char );
void LCD_dat (char );
void LCD_ram (char );
void LCD_clr (void );
void LCD_posyx (char, unsigned char );
void LCD_str(char *);
void LCD_ROMstr(const char *);
unsigned char LCD_chr1x(char, char, unsigned char);
unsigned char LCD_str1x(char *, char, unsigned char);
unsigned char LCD_ROMstr1x(const char *, char, unsigned char);
unsigned char LCD_chr2x(char, char, unsigned char);
unsigned char LCD_str2x(char *, char, unsigned char);
unsigned char LCD_ROMstr2x(const char *, char, unsigned char);
unsigned char LCD_chr3x(char, char, unsigned char);
unsigned char LCD_str3x(char *, char, unsigned char);
unsigned char LCD_ROMstr3x(const char *, char, unsigned char);

/******** NbN̎w *************************/
#ifndef _XTAL_FREQ
#define _XTAL_FREQ   16000000
#endif

/** Grafic LCD ֘AI/O *********************************************
     RC4  SPI_RS     LCD f[^         0:R}h  1:\f[^
     RC5  SPI_CS     `bvZNg         0:L      1:
************************************************************************/
    #define mInitLCD_IO()   LATC |= 0x30; TRISC &= 0xCF;
    
    #define SPI_RS          LATC4
    #define SPI_CS          LATC5

/******* SSP(SPI) ******************************************************
     SPI@\̐ݒ   }X^[hANbN = FOSC/4
        oX[h   ACh̃NbN : Hi 
        (MODE_11)    f[^M^C~O : NbN̗
                     Mf[^Tv   : SMPMID (NA)
     RC7  SPISDO     f[^o
     RB6  SPISCK     idle:Hi   SCK̗Ńf[^ύX
************************************************************************/

    #define mInitSPI()    {TRISC7=0;TRISB6=0;SSPSTAT=0x00;SSPCON1=0x30;}

/******** LN^f[^@(ASCII 0x20-0x7F) ************************
5x8 dot LN^f[^{ƂĂ邪A@
5dotȂ̋tHgiIȂǁj0xFFŏI[Ă
*********************************************************************/

const unsigned char chrom[96][5]={
        {0x00,0x00,0xFF,0x00,0x00},     // 0x20, Space
        {0x5F,0xFF               },     // 0x21, ! x
        {0x00,0x07,0x00,0x07,0x00},     // 0x22, " x
        {0x14,0x7F,0x14,0x7F,0x14},     // 0x23, #
        {0x24,0x2A,0x7F,0x2A,0x12},     // 0x24, $
        {0x27,0x15,0x6B,0x54,0x72},     // 0x25, %
        {0x36,0x49,0x56,0x20,0x50},     // 0x26, &
        {0x0B,0x07,0x00,0xFF     },     // 0x27, ' x
        {0x1C,0x22,0x41,0xFF     },     // 0x28, ( x
        {0x41,0x22,0x1C,0xFF     },     // 0x29, ) x
        {0x2A,0x1C,0x7F,0x1C,0x2A},     // 0x2a, *
        {0x08,0x08,0x3E,0x08,0x08},     // 0x2b, + x
        {0x58,0x38,0xFF          },     // 0x2c, , x
        {0x08,0x08,0x08,0x08,0x08},     // 0x2d, -
        {0x60,0x60,0xFF          },     // 0x2e, . x
        {0x20,0x10,0x08,0x04,0x02},     // 0x2f, /
        {0x3E,0x51,0x49,0x45,0x3E},     // 0x30, 0
        {0x42,0x7F,0x40,0xFF     },     // 0x31, 1 x
        {0x72,0x49,0x49,0x49,0x46},     // 0x32, 2
        {0x22,0x41,0x49,0x49,0x36},     // 0x33, 3
        {0x18,0x14,0x12,0x7F,0x10},     // 0x34, 4
        {0x27,0x45,0x45,0x45,0x39},     // 0x35, 5
        {0x3C,0x4A,0x49,0x49,0x30},     // 0x36, 6
        {0x01,0x71,0x09,0x05,0x03},     // 0x37, 7
        {0x36,0x49,0x49,0x49,0x36},     // 0x38, 8
        {0x06,0x49,0x49,0x29,0x1E},     // 0x39, 9
        {0x36,0x36,0xFF,0x00     },     // 0x3a, : x
        {0x5B,0x3B,0xFF,0x00     },     // 0x3b, ; x
        {0x08,0x14,0x22,0x41,0xFF},     // 0x3c, < x
        {0x14,0x14,0x14,0x14,0x14},     // 0x3d, =
        {0x41,0x22,0x14,0x08,0xFF},     // 0x3e, > x
        {0x02,0x01,0x51,0x09,0x06},     // 0x3f, ?
        {0x32,0x49,0x79,0x41,0x3E},     // 0x40, @
        {0x7C,0x12,0x11,0x12,0x7C},     // 0x41, A 
        {0x41,0x7F,0x49,0x49,0x36},     // 0x42, B 
        {0x3E,0x41,0x41,0x41,0x22},     // 0x43, C 
        {0x41,0x7F,0x41,0x41,0x3E},     // 0x44, D 
        {0x7F,0x49,0x49,0x41,0x41},     // 0x45, E 
        {0x7F,0x09,0x09,0x01,0x01},     // 0x46, F 
        {0x3E,0x41,0x49,0x49,0x3A},     // 0x37, G 
        {0x7F,0x08,0x08,0x08,0x7F},     // 0x48, H 
        {0x41,0x7F,0x41,0xFF     },     // 0x49, I
        {0x20,0x40,0x41,0x3F,0x01},     // 0x4a, J 
        {0x7F,0x08,0x14,0x22,0x41},     // 0x4b, K 
        {0x7F,0x40,0x40,0x40,0x40},     // 0x4c, L 
        {0x7F,0x02,0x0C,0x02,0x7F},     // 0x4d, M 
        {0x7F,0x02,0x04,0x08,0x7F},     // 0x4e, N 
        {0x3E,0x41,0x41,0x41,0x3E},     // 0x4f, O 
        {0x7F,0x09,0x09,0x09,0x06},     // 0x50, P 
        {0x3E,0x41,0x51,0x21,0x5E},     // 0x51, Q
        {0x7F,0x09,0x19,0x29,0x46},     // 0x52, R 
        {0x26,0x49,0x49,0x49,0x32},     // 0x53, S 
        {0x01,0x01,0x7F,0x01,0x01},     // 0x54, T 
        {0x3F,0x40,0x40,0x40,0x3F},     // 0x55, U 
        {0x07,0x18,0x60,0x18,0x07},     // 0x56, V 
        {0x7F,0x20,0x18,0x20,0x7F},     // 0x57, W 
        {0x63,0x14,0x08,0x14,0x63},     // 0x58, X 
        {0x03,0x04,0x78,0x04,0x03},     // 0x59, Y 
        {0x61,0x51,0x49,0x45,0x43},     // 0x5a, Z 
        {0x00,0x7F,0x41,0x41,0xFF},     // 0x5b, [ x
        {0x02,0x04,0x08,0x10,0x20},     // 0x5c, \ 
        {0x41,0x41,0x7F,0x00,0xFF},     // 0x5d, ] x
        {0x04,0x02,0x01,0x02,0x04},     // 0x5e, ^ 
        {0x40,0x40,0x40,0x40,0x40},      // 0x5f, _
        {0x00,0x03,0x04,0xFF,0xFF},     // 0x60, ` x
        {0x20,0x54,0x54,0x54,0x38},     // 0x61, a
        {0x7F,0x28,0x44,0x44,0x38},     // 0x62, b
        {0x38,0x44,0x44,0x44,0xFF},     // 0x63, c x
        {0x38,0x44,0x44,0x28,0x7F},     // 0x64, d
        {0x38,0x54,0x54,0x54,0x18},     // 0x65, e
        {0x08,0x3F,0x09,0x09,0x02},     // 0x66, f
//        {0x08,0x54,0x54,0x54,0x3C},   // 0x67, g
        {0x18,0xA4,0xA4,0x9C,0x78},     // 0x67, g
        {0x7F,0x08,0x04,0x04,0x78},     // 0x68, h
        {0x44,0x7D,0x40,0xFF     },     // 0x69, i x
        {0x20,0x40,0x44,0x3D,0xFF},     // 0x6a, j x
        {0x7F,0x10,0x28,0x44,0xFF},     // 0x6b, k x
        {0x41,0x7F,0x40,0xFF     },     // 0x6c, l x
        {0x7C,0x04,0x78,0x04,0x78},     // 0x6d, m
        {0x7C,0x08,0x04,0x04,0x78},     // 0x6e, n
        {0x38,0x44,0x44,0x44,0x38},     // 0x6f, o
//        {0x7C,0x14,0x14,0x14,0x08},   // 0x70, p
//        {0x08,0x14,0x14,0x14,0x7C},   // 0x71, q
        {0xFC,0x18,0x24,0x24,0x18},     // 0x70, p
        {0x18,0x24,0x24,0x18,0xFC},     // 0x71, q
        {0x7C,0x08,0x04,0x04,0x08},     // 0x72, r
        {0x48,0x54,0x54,0x54,0x24},     // 0x73, s
        {0x04,0x3F,0x44,0x44,0xFF},     // 0x74, t x
        {0x3C,0x40,0x40,0x20,0x7C},     // 0x75, u
        {0x1C,0x20,0x40,0x20,0x1C},     // 0x76, v
        {0x3C,0x40,0x30,0x40,0x3C},     // 0x77, w
        {0x44,0x28,0x10,0x28,0x44},     // 0x78, x
        {0x0C,0x90,0x90,0x90,0x7C},     // 0x79, y
        {0x24,0x64,0x54,0x4C,0x24},     // 0x7a, z
        {0x08,0x36,0x41     ,0xFF},     // 0x7b, x
        {0x00,0x7F,0x00     ,0xFF},     // 0x7c, | x
        {0x41,0x36,0x08     ,0xFF},     // 0x7d, } x
        {0x02,0x01,0x02,0x04,0x02},     // 0x7e, ~ x
        {0x7F,0x7F,0x7F,0x7F,0x7F},     // 0x7f, DELx
    };
